PreventSelling_Setup = {
	atMerchant = false;
};


function PreventSelling_OnLoad(frame)
	PreventSelling_UseContainerItem_Saved = UseContainerItem;
	UseContainerItem = PreventSelling_UseContainerItem;
	PreventSelling_UseInventoryItem_Saved = UseInventoryItem;
	UseInventoryItem = PreventSelling_UseInventoryItem;
	frame:SetScript("OnEvent", PreventSelling_OnEvent);
	frame:RegisterEvent("MERCHANT_SHOW");
	frame:RegisterEvent("MERCHANT_CLOSED");
end

function PreventSelling_OnEvent()
	if ( event == "MERCHANT_SHOW" ) then
		PreventSelling_Setup.atMerchant = true;
		return;
	elseif ( event == "MERCHANT_CLOSED" ) then
		PreventSelling_Setup.atMerchant = false;
		return;
	end
end

function PreventSelling_AllowSelling(link)
	if ( not link ) then return true; end
	local _, _, id = strfind(link, PREVENTSELLING_LINK_ITEM_ID_FIND);
	if ( not id ) then return true; end
	local sName, sLink, iQuality, iLevel, sType, sSubType, iCount = GetItemInfo(id);
	if ( iQuality >= PREVENTSELLING_EPIC_QUALITY ) then
		return false;
	end
	return true;
end

function PreventSelling_Print(msg)
	ChatFrame1:AddMessage(msg, 1, 1, 0);
end

function PreventSelling_UseContainerItem(bag,slot,p1,p2,p3)
	if ( PreventSelling_Setup.atMerchant ) then
		if ( not PreventSelling_AllowSelling(GetContainerItemLink(bag,slot)) ) then
			PreventSelling_Print(PREVENTSELLING_PREVENTED_MESSAGE);
			return;
		end
	end
	return PreventSelling_UseContainerItem_Saved(bag,slot,p1,p2,p3);
end

function PreventSelling_UseInventoryItem(slot,p1,p2,p3)
	if ( PreventSelling_Setup.atMerchant ) then
		if ( not PreventSelling_AllowSelling(GetInventoryItemLink("player",slot)) ) then
			PreventSelling_Print(PREVENTSELLING_PREVENTED_MESSAGE);
			return;
		end
	end
	return PreventSelling_UseInventoryItem_Saved(slot,p1,p2,p3);
end

local frame = CreateFrame("Frame","PreventSellingFrame");
PreventSelling_OnLoad(frame);
